//
//  AGUpdatePanel.h
//  AraeliumUpdate
//
//  Created by Seth Willits on 8/17/12.
//  Copyright (c) 2012 Araelium Group. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <AraeliumUpdate/AraeliumUpdate.h>
#import <WebKit/WebKit.h>


@interface AGUpdatePanel : NSPanel
{
	NSArray * mTopLevelObjects;
	IBOutlet NSView * mainView;
	IBOutlet NSTextField * titleField;
	IBOutlet NSTextField * secondaryField;
	IBOutlet WebView * webView;
	IBOutlet NSButton * installButton;
	IBOutlet NSButton * cancelButton;
	IBOutlet NSTextField * statusField;
	IBOutlet NSProgressIndicator * progressIndicator;
	
	BOOL mDisplayedAsSheet;
	BOOL mDisplayedAsModal;
	BOOL mAllowsDownloadingInBackground;
	AGUpdate * mUpdate;
}

@property (readwrite, retain) AGUpdate * appUpdate;
@property (readwrite, assign) BOOL allowsDownloadingInBackground;

+ (id)panel;
- (void)beginSheetModalForWindow:(NSWindow *)window completionHandler:(void (^)(NSInteger result))handler;
- (NSInteger)runModal __attribute__((deprecated("Modal windows prevent the AGUpdate from downloading. Use 'showWindow' instead.")));
- (void)showWindow;

@end
